var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var createRandomInteger = function (min, max) {
    if (min === void 0) { min = 0; }
    if (max === void 0) { max = 2147483646; }
    return Math.floor(Math.random() * (max - min + 1) + min);
};
var randShade = function (hue) { return ({
    hue: hue,
    saturation: createRandomInteger(50, 70),
    lightness: createRandomInteger(50, 60),
}); };
var hslString = function (color) {
    return "hsl(".concat(color.hue, ", ").concat(color.saturation, "%, ").concat(color.lightness, "%)");
};
var randScheme = function (base) {
    return [
        randShade(base),
        randShade((base + 60) % 360),
        randShade((base - 30) % 360),
        randShade((base + 30) % 360),
        randShade((base - 60) % 360),
    ].map(function (color) { return hslString(color); });
};
var svgRect = function (x, y, gridWidth, gridHeight, color) {
    return "<rect filter=\"url(#noise)\" x=\"".concat(x, "\" y=\"").concat(y, "\" width=\"").concat(gridWidth, "\" height=\"").concat(gridHeight, "\" fill=\"").concat(color, "\"/>");
};
var svgGridPattern = function (width, height, gridWidth, gridHeight, scheme) {
    return __spreadArray([], __read(Array(Math.floor(height / gridHeight)).keys()), false).map(function (y) {
        return __spreadArray([], __read(Array(Math.floor(width / gridWidth)).keys()), false).map(function (x) {
            return svgRect(x * gridWidth, y * gridHeight, gridWidth, gridHeight, scheme[x % 2]);
        });
    })
        .flat()
        .join("");
};
var backgroundSvg = function (width, height, _a) {
    var _b = _a === void 0 ? {} : _a, _c = _b.gridWidth, gridWidth = _c === void 0 ? createRandomInteger(5, 50) : _c, _d = _b.gridHeight, gridHeight = _d === void 0 ? createRandomInteger(5, 50) : _d, _e = _b.scheme, scheme = _e === void 0 ? randScheme(createRandomInteger(0, 360)) : _e, _f = _b.seeds, seeds = _f === void 0 ? [createRandomInteger(), createRandomInteger()] : _f;
    return "<svg width=\"".concat(width, "\" height=\"").concat(height, "\" viewBox=\"0 0 ").concat(width, " ").concat(height, "\"><filter id=\"noise\"><feTurbulence type=\"turbulence\" baseFrequency=\"0.005\" seed=\"").concat(seeds[0], "\" numOctaves=\"2\" result=\"turbulence\"/><feDisplacementMap in2=\"turbulence\" in=\"SourceGraphic\" scale=\"30\" xChannelSelector=\"R\" yChannelSelector=\"G\"/></filter><filter id=\"heavy\"><feTurbulence type=\"turbulence\" baseFrequency=\"0.005\" seed=\"").concat(seeds[1], "\" numOctaves=\"2\" result=\"turbulence\"/><feDisplacementMap in2=\"turbulence\" in=\"SourceGraphic\" scale=\"100\" xChannelSelector=\"R\" yChannelSelector=\"G\"/></filter><rect width=\"").concat(width, "\" height=\"").concat(height, "\" fill=\"").concat(scheme[4], "\"/><rect filter=\"url(#heavy)\"  width=\"").concat(width / 2, "\" height=\"").concat(height, "\" x=\"").concat(width / 5, "\" fill=\"").concat(scheme[2], "\"/><rect filter=\"url(#heavy)\" width=\"").concat(width / 2, "\" height=\"").concat(height, "\" x=\"").concat(width / 2, "\" fill=\"").concat(scheme[3], "\"/>").concat(svgGridPattern(width, height, gridWidth, gridHeight, scheme), "</svg>");
}; // eslint-disable-line
// prettier-ignore
var puzzlePieceSvg = function (_a) {
    var _b = _a === void 0 ? {} : _a, _c = _b.distort, distort = _c === void 0 ? false : _c, _d = _b.rotate, rotate = _d === void 0 ? false : _d, _e = _b.fill, fill = _e === void 0 ? '#000' : _e, _f = _b.stroke, stroke = _f === void 0 ? '#fff' : _f, _g = _b.seed, seed = _g === void 0 ? 0 : _g, _h = _b.opacity, opacity = _h === void 0 ? '0.5' : _h, _j = _b.strokeWidth, strokeWidth = _j === void 0 ? '0.25' : _j;
    return "<svg viewBox=\"0 0 20 20\" height=\"60\" width=\"60\"><filter id=\"noise\"><feTurbulence type=\"turbulence\" baseFrequency=\"0.05\" seed=\"".concat(seed, "\" numOctaves=\"2\" result=\"turbulence\"/><feDisplacementMap in2=\"turbulence\" in=\"SourceGraphic\" scale=\"2.5\" xChannelSelector=\"R\" yChannelSelector=\"G\"/></filter><path ").concat(distort ? 'filter="url(#noise)"' : '', " ").concat(rotate ? "transform=\"rotate(".concat(seed, ", 10, 10)\"") : '', " d=\"M5.56.56a2.305 2.305 0 00-2.296 2.304 2.305 2.305 0 00.801 1.747H.135v4.295a2.305 2.305 0 011.8-.865 2.305 2.305 0 012.304 2.306 2.305 2.305 0 01-2.305 2.304 2.305 2.305 0 01-1.8-.865v4.226H11.26v-4.258a2.305 2.305 0 001.781.842 2.305 2.305 0 002.305-2.305 2.305 2.305 0 00-2.305-2.305 2.305 2.305 0 00-1.78.841V4.611H7.072a2.305 2.305 0 00.801-1.747A2.305 2.305 0 005.57.559a2.305 2.305 0 00-.009 0z\" opacity=\"").concat(opacity, "\" stroke=\"").concat(stroke, "\" fill=\"").concat(fill, "\" stroke-width=\"").concat(strokeWidth, "\" stroke-linejoin=\"round\"/></svg>");
}; // eslint-disable-line
export { puzzlePieceSvg, backgroundSvg, createRandomInteger };
