import uid from "uid-safe";
// Solution must be correct within the given tolerance
var verifySolution = function (captcha, solution, tolerance) {
    return Math.abs(captcha - solution) < tolerance;
};
// Slider position must not jump to the solution without intermediate values
//TODO: correct any types
var verifyHorizontalMotion = function (positions) {
    return !positions.reduce(function (jumpToInput, pos) {
        return jumpToInput && (pos === 0 || pos === positions[positions.length - 1]);
    }, true);
};
// Vertical motion must be present while dragging the slider
//TODO: correct any types
var verifyVerticalMotion = function (positions) {
    return positions.reduce(function (total, pos) { return total + pos; }) !== 0;
};
var verifyTrailLength = function (trail) { return trail.x.length === trail.y.length; };
var verifyResponse = function (captcha, solution, trail, tolerance) {
    return verifySolution(captcha, solution, tolerance) &&
        verifyTrailLength(trail) &&
        verifyHorizontalMotion((trail.x, solution)) &&
        verifyVerticalMotion(trail.y);
};
//TODO: correct any types
var verifyCaptcha = function (captcha, _a, _b) {
    var response = _a.response, trail = _a.trail;
    var _c = _b === void 0 ? {} : _b, _d = _c.tolerance, tolerance = _d === void 0 ? 7 : _d, _e = _c.verify, verify = _e === void 0 ? verifyResponse : _e;
    return new Promise(function (resolve) {
        if (verify(captcha, response, trail, tolerance)) {
            uid(32).then(function (token) {
                resolve({
                    result: "success",
                    token: token,
                });
            });
        }
        else {
            resolve({ result: "failure" });
        }
    });
};
export default verifyCaptcha;
